unit DummyMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, ExtCtrls;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

type
  TDummyMainForm = class(TForm)
    PopupMenuRight: TPopupMenu;
    MenuAbout: TMenuItem;
    MenuExit: TMenuItem;
    ImageList1: TImageList;
    MenuRebootThisProgram: TMenuItem;
    ImageList2: TImageList;
    N1: TMenuItem;
    MenuSweeeeep: TMenuItem;
    MenuSweep10: TMenuItem;
    MenuSweep20: TMenuItem;
    MenuSweep30: TMenuItem;
    MenuSweep40: TMenuItem;
    MenuSweep50: TMenuItem;
    MenuSweep60: TMenuItem;
    MenuSweep70: TMenuItem;
    MenuSweep80: TMenuItem;
    MenuSweep90: TMenuItem;
    MenuEmptyRecycleBin: TMenuItem;
    N2: TMenuItem;
    MenuAutoEmptyMode: TMenuItem;
    MenuAutoEmptyModeON: TMenuItem;
    MenuAutoEmptyModeOFF: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuRebootThisProgramClick(Sender: TObject);
    procedure MenuEmptyRecycleBinClick(Sender: TObject);
    procedure MenuSweep10Click(Sender: TObject);
    procedure MenuAutoEmptyModeONClick(Sender: TObject);
    procedure MenuAutoEmptyModeOFFClick(Sender: TObject);
  private
    FAppSmallIcon: HICON;
    FAppLargeIcon: HICON;
    procedure TrayIconOnRightClick(Sender: TObject);
    procedure TrayIconOnLeftClick(Sender: TObject);
  private
    FTimerThread: TTimerThread;
    procedure UpdateForm();
    procedure ShowDriveSpace(const ADriveChar: Byte);
    procedure EmptyRecycleBin(const ADriveRoot: String);
  public
  end;

var
  DummyMainForm: TDummyMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const
    UNIQUE_NAM: string = '{B7188742-5D1C-46DA-9178-43DFBFCC0FA5}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

{$R *.dfm}

uses
    iTray, Info, ShellAPI;

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    if (not IsWindowVisible(DummyMainForm.PopupMenuRight.Handle)) then
    begin
        DummyMainForm.UpdateForm();
    end;
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(100);
    end;
end;

//-----------------------------------------------------------------------------
//  oCg\KoCg
function B2MB(const inByte: Int64): string;
begin
    Result := FormatFloat('#,##0.00MB', Round(inByte / (1024 * 1024)));
end;

//-----------------------------------------------------------------------------
//  gCACRĂ΂郁\bh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  ENbN|bvAbvj[\
procedure TDummyMainForm.TrayIconOnRightClick(Sender: TObject);
begin
    SetForegroundWindow(Handle);
    PopupMenuRight.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

//-----------------------------------------------------------------------------
procedure TDummyMainForm.TrayIconOnLeftClick(Sender: TObject);
begin
    //
end;

//-----------------------------------------------------------------------------
//  ^XNo[ɕ\Ȃ߂̃_~[CtH[
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TDummyMainForm.FormCreate(Sender: TObject);
var
    R: TRect;
begin
    //  CtH[\
    Application.ShowMainForm := False;

    //  AvP[VEBhEB
    ShowWindow(Application.Handle, SW_HIDE);

    //  ^Ɉړ
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Self.Left := (R.Right - R.Left - Self.Width) div 2;
    Self.Top := (R.Bottom - R.Top - Self.Height) div 2;

    //  ACR擾
    ExtractIconEx(PChar(ParamStr(0)), 0, FAppLargeIcon, FAppSmallIcon, 1);

    //  gCACR\
    if FAppSmallIcon <> 0 then
        SimpleTray := TSimpleTaskTray.Create(FAppSmallIcon)
    else
        SimpleTray := TSimpleTaskTray.Create(Application.Icon.Handle)
    ;
    SimpleTray.FOnLeftClick := TrayIconOnLeftClick;
    SimpleTray.FOnRightClick := TrayIconOnRightClick;
    SimpleTray.AddTray(ExtractFileName(ParamStr(0)));

    //  ^C}[Xbh
    FTimerThread := TTimerThread.Create(False);
end;

//-----------------------------------------------------------------------------
//  I
procedure TDummyMainForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    //  ^C}[XbhI
    FTimerThread.Free();
    //  gCACR~
    SimpleTray.Free();
end;

//-----------------------------------------------------------------------------
//  j[Cxgnh
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//  ̃vOɂ
procedure TDummyMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  AvP[VI
procedure TDummyMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

//-----------------------------------------------------------------------------
//  AvP[VċN
procedure TDummyMainForm.MenuRebootThisProgramClick(Sender: TObject);
begin
    SimpleShellExecute(ParamStr(0), UNIQUE_NAM);
    Self.Close();
end;

//-----------------------------------------------------------------------------
//  |sXbh
type
    TSweepThread = class(TThread)
    private
        FDone: Boolean;
        FSweepSize: Cardinal;
    protected
        procedure Execute(); override;
    public
        constructor Create(const SweepSize: Cardinal);
    public
        property Done: Boolean read FDone;
    end;

//-----------------------------------------------------------------------------
constructor TSweepThread.Create(const SweepSize: Cardinal);
begin
    inherited Create(True);
    FDone := False;
    FSweepSize := SweepSize;
    Resume();
end;

//-----------------------------------------------------------------------------
procedure TSweepThread.Execute();
var
    AllocPointer: Pointer;  //  mۂ̃AhX
begin
    //  Windowsɗv
    AllocPointer := VirtualAlloc(nil, FSweepSize, MEM_COMMIT, PAGE_READWRITE or PAGE_NOCACHE);

    try
        //  ۂɃANZXȂƂ(?)
        FillMemory(AllocPointer, FSweepSize, 0);
    finally
        //  
        VirtualFree(AllocPointer, FSweepSize, MEM_DECOMMIT);
    end;

    //  I
    FDone := True;
end;

//-----------------------------------------------------------------------------
//  |s
procedure TDummyMainForm.MenuSweep10Click(Sender: TObject);
var
    MenuItem: TMenuItem;
    MemoryStatus: TMemoryStatus;
    SweepRatio: double;
    dwFull, dwAvail, dwSize: Cardinal;
    HintText: string;
    Sweeper: TSweepThread;
    i: integer;
    Temp: TIcon;
    Icon: HICON;
begin
    //  ̉J邩
    MenuItem := TMenuItem(Sender);
    SweepRatio := MenuItem.Tag / 100;

    //  TCY擾
    FillChar(MemoryStatus, SizeOf(MemoryStatus), 0);
    MemoryStatus.dwLength := SizeOf(TMemoryStatus);
    GlobalMemoryStatus(MemoryStatus);
    dwFull := MemoryStatus.dwTotalPhys;
    dwAvail := MemoryStatus.dwAvailPhys;

    //  JTCYݒ
    dwSize := Trunc(dwFull * SweepRatio);

    //  Jn
    HintText := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now())
              + #13#10#13#10
              + 'Total Phisical Memory: ' + B2MB(dwFull)
              + #13#10
              + 'Free Phisical Memory: ' + B2MB(dwAvail)
              + #13#10#13#10
              + 'Sweep Setting: ' + IntToStr(MenuItem.Tag) + '% (' + B2MB(dwSize) + ')';

    SimpleTray.ShowBalloon(HintText, Application.Title, bitINFO, mtBALLOON);

    //  XbhŎs
    Sweeper := nil;
    try
        try
            Sweeper := TSweepThread.Create(dwSize);
            i := 0;
            while not Sweeper.Done do
            begin
                Temp := nil;
                try
                    Temp := TIcon.Create;
                    try
                        ImageList1.GetIcon(i, Temp);
                        Icon := Temp.Handle;
                        SimpleTray.ModTray(Icon);
                    finally
                        FreeAndNil(Temp);
                    end;
                except
                    ;
                end;
                Sleep(100);
                Inc(i);
                if (i >= ImageList1.Count) then i := 0;
            end;
            if FAppSmallIcon <> 0 then
                SimpleTray.ModTray(FAppSmallIcon)
            else
                SimpleTray.ModTray(Application.Icon.Handle)
            ;
            Sweeper.Terminate;
        finally
            FreeAndNil(Sweeper);
        end;
    except
        ;
    end;

    //  TCYēx擾
    FillChar(MemoryStatus, SizeOf(MemoryStatus), 0);
    MemoryStatus.dwLength := SizeOf(TMemoryStatus);
    GlobalMemoryStatus(MemoryStatus);
    dwFull := MemoryStatus.dwTotalPhys;
    dwAvail := MemoryStatus.dwAvailPhys;

    //  
    HintText := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now())
              + #13#10#13#10
              + 'Total Phisical Memory: ' + B2MB(dwFull)
              + #13#10
              + 'Free Phisical Memory: ' + B2MB(dwAvail)
              + #13#10#13#10
              + 'Sweep Complete';

    SimpleTray.HideBalloon();
    SimpleTray.ShowBalloon(HintText, Application.Title, bitINFO, mtBALLOON);
end;

//-----------------------------------------------------------------------------
//  S~ɂ
procedure TDummyMainForm.MenuEmptyRecycleBinClick(Sender: TObject);
begin
    EmptyRecycleBin('C:\');
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TDummyMainForm.UpdateForm();
begin
    //  C:\  3
    ShowDriveSpace(3);

    //  폜H
    if (MenuAutoEmptyModeON.Checked) then
    begin
        EmptyRecycleBin('C:\');
    end;
end;

//-----------------------------------------------------------------------------
//  S~
procedure TDummyMainForm.EmptyRecycleBin(const ADriveRoot: String);
var
    LText: String;
    LIcon: TBalloonIconType;
    LSize: Int64;
begin
    LSize := Info.RecycleBinSize(ADriveRoot);
    if (LSize > 0) then
    begin
        Info.EmptyRecycleBin(True);

        if (MenuAutoEmptyModeON.Checked) then
        begin
            LText := 'AutoEmptyMode ON';
            LIcon := bitWARN;
        end
        else
        begin
            LText := 'AutoEmptyMode OFF';
            LIcon := bitINFO;
        end;
        LText := LText + #13#10 + 'EmptyRecycleBin Executed.'
                       + #13#10 + Format('%d bytes Deleted.', [LSize]);

        SimpleTray.HideBalloon();
        SimpleTray.ShowBalloon(LText, Application.Title, LIcon, mtBALLOON);
    end;
end;

//-----------------------------------------------------------------------------
//  hCu̗eʂACRɕ\
procedure TDummyMainForm.ShowDriveSpace(const ADriveChar: Byte);
var
    LFree: Int64;
    LFreeDbl: Double;
    Temp: TIcon;
    Icon: HICON;
    LSize: Int64;
begin
    LFree := DiskFree(ADriveChar);
    //  KB
    LFreeDbl := LFree / 1024;
    //  MB
    LFreeDbl := LFreeDbl / 1024;
    //  GB
    LFreeDbl := LFreeDbl / 1024;
    //  
    LFree := Trunc(LFreeDbl * 10);
    case LFree of
    0..9:
        begin
            Temp := nil;
            try
                Temp := TIcon.Create;
                try
                    ImageList2.GetIcon(LFree, Temp);
                    Icon := Temp.Handle;
                    SimpleTray.ModTray(Icon);
                finally
                    FreeAndNil(Temp);
                end;
            except
                ;
            end;
        end;
    else
        if FAppSmallIcon <> 0 then
        begin
            SimpleTray.ModTray(FAppSmallIcon);
        end
        else
        begin
            SimpleTray.ModTray(Application.Icon.Handle);
        end;
    end;

    LSize := Info.RecycleBinSize('C:\');
    if (LSize > 0) then
    begin
        SimpleTray.ModTray(
            Application.Title
            + #13#10
            + Format('%d bytes in RecycleBin', [LSize])
            );
    end
    else
    begin
        SimpleTray.ModTray(Application.Title);
    end;
end;

//-----------------------------------------------------------------------------
//  ۃ[hI̊mF
procedure TDummyMainForm.MenuAutoEmptyModeONClick(Sender: TObject);
var
    LText: String;
begin
    LText := 'Are you SURE ? (At Your Own Risk !)';
    if (AppMessageBox(LText, MB_ICONQUESTION or MB_OKCANCEL) = ID_OK) then
    begin
        MenuAutoEmptyModeON.Checked := True;

        LText := 'AutoEmptyMode ON';
        SimpleTray.HideBalloon();
        SimpleTray.ShowBalloon(LText, Application.Title, bitWARN, mtBALLOON);
    end;
end;

//-----------------------------------------------------------------------------
//  ۃ[hIt̊mF
procedure TDummyMainForm.MenuAutoEmptyModeOFFClick(Sender: TObject);
var
    LText: String;
begin
    LText := 'AutoEmptyMode OFF';
    SimpleTray.HideBalloon();
    SimpleTray.ShowBalloon(LText, Application.Title, bitINFO, mtBALLOON);
end;

end.

